/*
 *	XMEM_UNIX -- external memory access interface.
 *	Copyright (C) 2000 Nils M Holm. All rights reserved.
 *	See the file LICENSE for conditions of use.
 */

#include <stdio.h>
#include <stdlib.h>

#define MAXBLOCKS	16

#define uchar	unsigned char
#define ushort	unsigned short
#define uint	unsigned int
#define ulong	unsigned long


uchar	*Blocks[MAXBLOCKS];


xmem_init() {
	int	i;

	for (i=0; i<MAXBLOCKS; i++) Blocks[i] = NULL;
}


xmem_alloc(size)
uint	size;
{
	int	i;

	for (i=0; i<MAXBLOCKS; i++)
		if (Blocks[i] == NULL) break;
	if (i >= MAXBLOCKS) return -1;
	if ((Blocks[i] = (uchar *) malloc(size)) == NULL)
		return -1;
	return i;
}


xmem_free(id) {
	if (Blocks[id] == NULL) return -1;
	free(Blocks[id]);
	Blocks[id] = NULL;
	return 0;
}


xmem_get(id, x)
int	id;
uint	x;
{
	return Blocks[id][x];
}


xmem_put(id, x, v)
int	id;
uint	x, v;
{
	return Blocks[id][x] = v;
}

