#!/bin/sh

# install script for the Tcode port

# TXBASE	where to install the package
# TXDIR		don't change
# BINDIR	location of the binaries (tx6, txx3, etc)
# DOCDIR	online documents
# MANDIR	where to place the man page
# EXMDIR	where to place the example programs

TXBASE=/usr/local/t3x
TXDIR=$TXBASE/r6
BINDIR=/usr/local/bin
DOCDIR=/usr/local/share/doc/t3x
MANDIR=/usr/local/man/man7
EXMDIR=/usr/local/share/examples/t3x

rm -f $BINDIR/tx6 $BINDIR/txx3 $BINDIR/txcm $BINDIR/txdump $BINDIR/txprint

mkdir $TXBASE && chmod 0755 $TXBASE && chown bin:bin $TXBASE
mkdir $TXDIR && chmod 0755 $TXDIR && chown bin:bin $TXDIR
mkdir $TXDIR/bin && chmod 0755 $TXDIR/bin && chown bin:bin $TXDIR/bin
mkdir $TXDIR/classes && chmod 0755 $TXDIR/classes && \
	chown bin:bin $TXDIR/classes
mkdir $DOCDIR && chmod 0755 $DOCDIR && chown bin:bin $DOCDIR
mkdir $EXMDIR && chmod 0755 $EXMDIR && chown bin:bin $EXMDIR

cp t3x.dir $TXDIR/classes
cp tcode.dir $TXDIR/classes
touch $TXDIR/classes/tcode.cls
cp ../classes/char.dir $TXDIR/classes
cp ../classes/char.cls $TXDIR/classes
cp ../classes/iostream.dir $TXDIR/classes
cp ../classes/iostream.cls $TXDIR/classes
cp ../classes/memory.dir $TXDIR/classes
cp ../classes/memory.cls $TXDIR/classes
cp ../classes/string.dir $TXDIR/classes
cp ../classes/string.cls $TXDIR/classes
cp ../classes/r5c.cls $TXDIR/classes
echo "char:" >$TXDIR/classes/CLASSNDX
echo "iostream:" >>$TXDIR/classes/CLASSNDX
echo "memory:" >>$TXDIR/classes/CLASSNDX
echo "string:" >>$TXDIR/classes/CLASSNDX
chmod 0644 $TXDIR/classes/*
chown bin:bin $TXDIR/classes/*

cp ../compiler/txx $TXDIR/bin
cp ../tools/tx $TXDIR/bin
cp ../tools/txcm $TXDIR/bin
cp ../tools/txdump $TXDIR/bin
cp ../tools/txprint $TXDIR/bin
cp ../compiler/txtrn $TXDIR/bin
cp ../compiler/txld $TXDIR/bin
cp ../compiler/txopt $TXDIR/bin
cp ../compiler/txdpf $TXDIR/bin
chown bin:bin $TXDIR/bin/*
chmod 0644 $TXDIR/bin/*
chmod 0755 $TXDIR/bin/txx $TXDIR/bin/tx
cp $TXDIR/bin/txx $BINDIR/txx3 && chown bin:bin $BINDIR/txx3 && \
	chmod 0755 $BINDIR/txx3
cp $TXDIR/bin/tx $BINDIR/tx6 && chown bin:bin $BINDIR/tx6 && \
	chmod 0755 $BINDIR/tx6

echo "#! /bin/sh" >$BINDIR/txcm
echo "$TXDIR/bin/txx $TXDIR/bin/txcm \$*" >>$BINDIR/txcm
echo "#! /bin/sh" >$BINDIR/txdump
echo "$TXDIR/bin/txx $TXDIR/bin/txdump \$*" >>$BINDIR/txdump
echo "#! /bin/sh" >$BINDIR/txprint
echo "$TXDIR/bin/txx $TXDIR/bin/txprint \$*" >>$BINDIR/txprint
chown bin:bin $BINDIR/txcm $BINDIR/txdump $BINDIR/txprint
chmod 0755 $BINDIR/txcm $BINDIR/txdump $BINDIR/txprint

cp ../tools/txprint.rules $TXDIR/txprint.rules && \
	chown bin:bin $TXDIR/txprint.rules && \
	chmod 0644 $TXDIR/txprint.rules && \

cp ../docs/README.docs $DOCDIR
cp ../docs/README $DOCDIR
cp ../docs/README $DOCDIR
cp ../docs/Changes $DOCDIR
cp ../docs/BOOT.HOWTO $DOCDIR
cp ../docs/BOOT.HOWTO $DOCDIR
cp ../docs/FAQ $DOCDIR
cp ../docs/KNOWNBUGS $DOCDIR
cp ../docs/LICENSE $DOCDIR
cp ../docs/*.html $DOCDIR
cp ../docs/*.sd $DOCDIR
cp ../docs/sdv-config $DOCDIR
chown bin:bin $DOCDIR/*
chmod 0644 $DOCDIR/*

cp ../docs/t3x.7 $MANDIR/t3x.7
chown bin:bin $MANDIR/t3x.7
chmod 0644 $MANDIR/t3x.7

echo "#! /bin/sh" >$BINDIR/ux3
echo "$TXDIR/bin/txx $TXDIR/bin/txdump -u \$*" >>$BINDIR/ux3
chown bin:bin $BINDIR/ux3
chmod 0755 $BINDIR/ux3
