!	GENCLDIRS -- generate initial class directories
!	Copyright (C) 1999,2000 Nils M Holm. All rights reserved.
!	See the file LICENSE for conditions of use.
!
!	SYNTAX: GENCLDIRS <CLASSDIR

module gencldirs(t3x);

object	t[t3x];

!--- From TXTRN ---!
struct	SYMREC =
	SNAME,
	SVAL,
	SSIZE,
	SFLAGS;
struct SR2 =
	SNL, SNH,
	SVL, SVH,
	SZL, SZH,
	SFL, SFH;
const	CNST=	1,
	GLOBL=	2,
	PROC=	4,
	PROTO=	8,
	SYS=	16,
	PUBLC=	32,
	EXTRN=	64,
	CLSS=	128,
	OBJCT=	256,
	IVAR=	512,
	REDIR=	1024,
	LINKD=	2048;
const	CACHESPACE =	4096,
	NAMESPACE =	8192;
!------------------!


var	Symbols[CACHESPACE];
var	Names::NAMESPACE+1;


length(s) do var k;
	k := 0;
	while (s::k) k := k+1;
	return k;
end


writep(f, s) t.write(T3X.SYSOUT, s, length(s));


wrout(s) writep(T3X.SYSOUT, s);


nl(f) do var b::3;
	writep(f, t.newline(b));
end


error(m) do
	writep(T3X.SYSERR, packed"GENCLDIR: ");
	writep(T3X.SYSERR, m);
	nl(T3X.SYSERR);
	halt 1;
end


writedir(tbl, n) do
	var	k, i, dir, dirname::256, name, s, sfx;
	var	fwerr;
	var	nb::2;

	fwerr := packed"file write error";
	s := @Names::(tbl::SNH << 8 | tbl::SNL);
	t.memcopy(dirname, s, length(s)+1);
	k := 0;
	while (dirname::k) k := k+1;
	sfx := packed".dir";
	for (i=0, 5) dirname::(k+i) := sfx::i;
	name := dirname;
	wrout(name);
	wrout(packed": ");
	dir := t.open(name, T3X.OWRITE);
	if (dir < 0) error(packed"file creation failed");
	if (t.write(dir, packed"CDIR", 4) \= 4) error(fwerr);
	nb::0 := n & 255;
	nb::1 := n >> 8;
	if (t.write(dir, nb, 2) \= 2) error(fwerr);
	if (t.write(dir, tbl, n*SR2) \= n*SR2) error(fwerr);
	for (i=0, n*SR2, SR2) do
		s := @Names::(tbl::(i+SNH) << 8 | tbl::(i+SNL));
		k := 0;
		while (s::k) k := k+1;
		k := k+1;
		if (t.write(dir, s, k) \= k) error(fwerr);
	end
	t.close(dir);
	wrout(packed"created"); nl(T3X.SYSOUT);
end


gencldirs(n) do var i, j, f;
	for (i=0, n*SR2, SR2) do
		f := Symbols::(i+SFH) << 8 | Symbols::(i+SFL);
		if (f & CLSS) do
			j := i;
			while (1) do
				if (	\(Symbols::(j+SFH) << 8 |
					  Symbols::(j+SFL))
				)
					leave;
				if (j >= n*SR2)
					error(packed"missing end of class");
				j := j+SR2;
			end
			writedir(@Symbols::i, (j+SR2-i)/SR2);
		end
	end
end


do
	var hd::4, i, n, p, nb::2;

	if (t.read(0, hd, 4) \= 4 \/ t.memcomp(hd, packed"CDIR", 4))
		error(packed"magic match failed");
	if (t.read(0, nb, 2) \= 2) error(packed"short file");
	n := nb::1 << 8 | nb::0;
	if (t.read(0, Symbols, n*SR2) \= n*SR2)
 		error(packed"short file");
	if (t.read(0, Names, NAMESPACE+1) = NAMESPACE+1)
		error(packed"file too long");
	p := 0;
	for (i=0, n*SR2, SR2) do
		Symbols::(i+SNL) := p & 255;
		Symbols::(i+SNH) := p >> 8;
		p := p+length(@Names::p)+1;
	end
	gencldirs(n);
end
