!	T3X runtime class: T3X-R5 compatibility routines
!	Copyright (C) 1999 Nils M Holm. All rights reserved.
!	See the file LICENSE for conditions of use.

module r5c();


var	Input, Output;
var	Ntoa_buf[256];


public class r5c(t3x, string)

 object	t[t3x],
	str[string];

 ! XXX hack: this DECL is equired to force subsequent label IDs
 decl	open(2), close(1), erase(1), select(2), reads(2), writes(1),
	newline(0), aton(1), ntoa(2), pack(2), unpack(2),
	readpacked(3), writepacked(3), reposition(4), rename(2),
	memcopy(3), memcomp(3);


 public open(file, mode) do var pname::256;
	t.pack(file, pname);
	return t.open(pname, mode);
 end


 public close(fd) return t.close(fd);


 public erase(name) do var pname::256;
	t.pack(name, pname);
	return t.remove(pname);
 end


 public select(port, fd) do var old;
	ie (port) do
		old := Output;
		Output := fd;
	end
	else do
		old := Input;
		Input := fd;
	end
	return old;
 end


 public reads(s, max) do var buf::1025, k, i;
	k := t.read(Input, buf, max);
	for (i=0, k) s[i] := buf::i;
	s[i] := 0;
	return k;
 end


 public writes(s) do var buf::1025, k;
	k := 0;
	while (s[k]) k := k+1;
	if (k > 1024) return %1;
	t.pack(s, buf);
	return t.write(Output, buf, k);
 end


 public newline() do var b::10, i;;
	t.newline(b);
	for (i=0,10) if (\b::i) leave;
	t.write(Output, b, i);
 end


 public aton(s) do var buf::256;
	t.pack(s, buf);
	return str.strtonum(buf, 10, 0);
 end


 public ntoa(n, width) do var buf::256+34, k;
	t.memfill(buf, '\s', 256+34);
	str.numtostr(@buf::256, n, -10);
	k := 256;
	while (buf::k) k := k+1;
	ie (k-256 > width)
		k := 256;
	else
		k := 256 - (width - k + 256);
	t.unpack(@buf::k, Ntoa_buf);
	return Ntoa_buf;
 end


 public pack(v, s) return t.pack(v, s);


 public unpack(s, v) return t.unpack(s, v);


 public readpacked(fd, buf, len) return t.read(fd, buf, len);


 public writepacked(fd, buf, len) return t.write(fd, buf, len);


 seek64(fd, mode) do
	t.seek(fd, 16384, mode);
	t.seek(fd, 16384, mode);
	t.seek(fd, 16384, mode);
	t.seek(fd, 16384, mode);
 end

 public reposition(fd, offh, offl, how) do var mode;
	if (how < 0 \/ how > 2) return %1;
	if (how = 0) t.seek(fd, 0, t3x.SEEK_SET);	! SEEK_SET
	if (how = 2) t.seek(fd, 0, t3x.SEEK_END);	! SEEK_END
	mode := offh < 0 -> t3x.SEEK_BCK: t3x.SEEK_FWD;	! SEEK_REL
	if (offh < 0) offl := -offl;
	while (offh < -1) do
		seek64(fd, mode);
		offh := offh+1;
	end
	while (offh > 0) do
		seek64(fd, mode);
		offh := offh-1;
	end
	return t.seek(fd, offl, mode);
 end


 public rename(old, new) do var oldp::256, newp::256;
	t.pack(old, oldp);
	t.pack(new, newp);
	return t.rename(oldp, newp);
 end


 public memcopy(dest, src, len) return t.memcopy(dest, src, len);


 public memcomp(r1, r2, len) return t.memcomp(r1, r2, len);

end


do
	Input := 0;
	Output := 1;
end
