!	T3X runtime extension: TTY control
!	Copyright (C) 1999 Nils M Holm. All rights reserved.
!	See the file LICENSE for conditions of use.

module ttyctl();


public class ttyctl(t3x)

 object	t[t3x];


 var	TTYso;

 var	tty_writec,
	tty_writes,
	tty_clear,
	tty_clreol,
	tty_color,
	tty_query,
	tty_readc,
	tty_move,
	tty_scroll,
	tty_rscroll,
	tty_mode,
	tty_fini,
	tty_ncols,
	tty_nlines,
	tty_cancolor;

 public struct	SCRN = SCRN_X, SCRN_Y, SCRN_C;

 public const	K_HOME	= 327,
		K_LEFT	= 331,
		K_RIGHT	= 333,
		K_END	= 335,
		K_BKSP	= '\b',
		K_DEL	= 339,
		K_KILL	= 127,
		K_INS	= 338,
		K_CR	= '\r',
		K_UP	= 328,
		K_DOWN	= 336,
		K_ESC	= '\e',
		K_PGUP	= 329,
		K_PREV	= K_PGUP,
		K_PGDN	= 337,
		K_NEXT	= K_PGDN,
		K_F1	= 315,
		K_F2	= 316,
		K_F3	= 317,
		K_F4	= 318,
		K_F5	= 319,
		K_F6	= 320,
		K_F7	= 321,
		K_F8	= 322,
		K_F9	= 323,
		K_F10	= 324;

public const	F_BLACK		= 0,
		F_BLUE		= 1,
		F_GREEN		= 2,
		F_CYAN		= 3,
		F_RED		= 4,
		F_MAGENTA	= 5,
		F_YELLOW	= 6,
		F_GREY		= 7,
		F_BRIGHT	= 8,
		B_BLACK		= 0,
		B_BLUE		= 16,
		B_GREEN		= 32,
		B_CYAN		= 48,
		B_RED		= 64,
		B_MAGENTA	= 80,
		B_YELLOW	= 96,
		B_GREY		= 112;


 length(s) return t.memscan(s,0,32767);

 abort(msg, name) do
	t.write(2,packed"TTYCTL: ",8);
	t.write(2,msg,length(msg));
	t.write(2,packed": ",2);
	t.write(2,name,length(name));
	t.write(2,packed"\r\n",2);
	halt -1;
 end


 call0(p) return t.shlcall(p, [0,0]);

 call1(p, a) return t.shlcall(p, [1, 0, (a)]);

 call2(p, a1, a2) return t.shlcall(p, [2, 0, (a1), (a2)]);


 link(name, psym) do var sym;
	sym := t.shlsym(TTYso, name);
	if (sym < 0) abort(packed"cannot find procedure", name);
	psym[0] := sym;
 end


 public init() do var r, tty_init;
	TTYso := t.shlopen(packed"ttyctl.so");
	if (TTYso < 0)
		abort(packed"cannot open TTY module", packed"ttyctl.so");
	link(packed"_tty_init", @tty_init);
	call0(tty_init);
	link(packed"_tty_writec", @tty_writec);
	link(packed"_tty_writes", @tty_writes);
	link(packed"_tty_clear", @tty_clear);
	link(packed"_tty_clreol", @tty_clreol);
	link(packed"_tty_color", @tty_color);
	link(packed"_tty_query", @tty_query);
	link(packed"_tty_readc", @tty_readc);
	link(packed"_tty_move", @tty_move);
	link(packed"_tty_scroll", @tty_scroll);
	link(packed"_tty_rscroll", @tty_rscroll);
	link(packed"_tty_mode", @tty_mode);
	link(packed"_tty_fini", @tty_fini);
	link(packed"_tty_ncols", @tty_ncols);
	link(packed"_tty_nlines", @tty_nlines);
	link(packed"_tty_cancolor", @tty_cancolor);
 end


 public writec(c) do
	return call1(tty_writec, c);
 end


 public writes(s) do
	return t.shlcall(tty_writes, [1,1,(s)]);
 end


 public clear() do
	return call0(tty_clear);
 end


 public clreol() do
	return call0(tty_clreol);
 end


 public color(m) do
	return call1(tty_color, m);
 end


 public query() do
	return call0(tty_query);
 end


 public readc() do
	return call0(tty_readc);
 end


 public move(x, y) do
	return call2(tty_move, x, y);
 end


 public scroll(top, bot) do
	return call2(tty_scroll, top, bot);
 end


 public rscroll(top, bot) do
	return call2(tty_rscroll, top, bot);
 end


 public mode(m) do
	return call1(tty_mode, m);
 end


 public fini() do
	call0(tty_fini);
	return t.shlclose(TTYso);
 end


 public screentype(p) do
	p[SCRN_X] := call0(tty_ncols);
	p[SCRN_Y] := call0(tty_nlines);
	p[SCRN_C] := call0(tty_cancolor);
	if (p[SCRN_X] < 0 \/ p[SCRN_Y] < 0 \/ p[SCRN_C] < 0) return -1;
 end

end


do
end
