!	T3X runtime extension: EXTERNAL MEMORY interface
!	Copyright (C) 2000 Nils M Holm. All rights reserved.
!	See the file LICENSE for conditions of use.

module xmem();


public class xmem(t3x)

 object	t[t3x];

 var	SO;
 var	xmem_init,
 	xmem_alloc,
 	xmem_free,
 	xmem_get,
 	xmem_put;


 length(s) return t.memscan(s,0,32767);

 abort(msg, name) do
	t.write(2,packed"XMEM: ",6);
	t.write(2,msg,length(msg));
	t.write(2,packed": ",2);
	t.write(2,name,length(name));
	t.write(2,packed"\r\n",2);
	halt -1;
 end


 call0(p) return t.shlcall(p, [0,0]);

 call1(p, a) return t.shlcall(p, [1, 0, (a)]);

 call2(p, a1, a2) return t.shlcall(p, [2, 0, (a1), (a2)]);

 call3(p, a1, a2, a3) return t.shlcall(p, [3, 0, (a1), (a2), (a3)]);


 link(name, psym) do var sym;
	sym := t.shlsym(SO, name);
	if (sym < 0) abort(packed"cannot find procedure", name);
	psym[0] := sym;
 end


 public init() do var r, tty_init;
	SO := t.shlopen(packed"xmem.so");
	if (SO < 0)
		abort(packed"cannot open XMEM module", packed"xmem.so");
	link(packed"_xmem_init", @xmem_init);
	call0(xmem_init);
	link(packed"_xmem_alloc", @xmem_alloc);
	link(packed"_xmem_free", @xmem_free);
	link(packed"_xmem_get", @xmem_get);
	link(packed"_xmem_put", @xmem_put);
 end


 public alloc(n) return call1(xmem_alloc, n);


 public free(id) return call1(xmem_free, id);


 public get(id, x) return call2(xmem_get, id, x);


 public put(id, x, v) return call3(xmem_put, id, x, v);


 public fini() do
	return t.shlclose(SO);
 end

end


do
end
