!	TXDUMP -- Examine Tcode programs
!	Copyright (C) 2000 Nils M Holm.  All rights reserved.
!	See the file LICENSE for conditions of use.

#classpath "../classes";
#packstrings;

module txdump(t3x, iostream, string);

object	t[t3x], str[string];


const	BUFSIZE = 1024;

const	M_INFO=0, M_UX=1, M_BANG=2;

const	IINIT = 0x89;	! valid for all Tcode versions
const	IDECL = 0x83;
const	IDATA = 0x84;
const	ICREF = 0x85;
const	IDREF = 0x86;
const	ISTR  = 0x87;
const	IPSTR = 0x88;
const	IHDR = 0x0A;

const	STACK12 = 178;
const	STACK3 = 0x91;

var	Addr;
var	K64;
var	Tc[4], Opcodes, Lastop, Td, Decls, Ndcl;
object	In[iostream], Out[iostream];
var	Inbuf::BUFSIZE, Outbuf::BUFSIZE;
var	Nlstr::4;
var	O_mode, O_hex, O_one;
var	Name;
var	Header::256;


init() do
	K64 := 16384;	! avoid 16-bit constant folding
	K64 := K64 << 2;
	t.newline(Nlstr);
	Tc[1] := [
	[ 129, "CLAB",	"N"	],
	[ 130, "DLAB",	"N"	],
	[ 131, "DECL",	"N"	],
	[ 132, "DATA",	"N"	],
	[ 133, "CREF",	"N"	],
	[ 134, "DREF",	"N"	],
	[ 135, "STR",	"NB"	],
	[ 136, "PSTR",	"NB"	],
	[ 137, "INIT",	"N"	],
	[  10, "HDR",	""	],
	[  11, "END",	""	],
	[  12, "NEG",	""	],
	[  13, "LNOT",	""	],
	[  14, "BNOT",	""	],
	[  15, "POP",	""	],
	[ 144, "CLEAN",	"N"	],
	[  17, "NOP",	""	],
	[  18, "INDB",	""	],
	[  19, "IND",	""	],
	[  20, "DREFB",	""	],
	[  21, "DEREF",	""	],
	[ 150, "INCG",	"NN"	],
	[ 151, "INCL",	"NN"	],
	[  24, "MUL",	""	],
	[  25, "DIV",	""	],
	[  26, "MOD",	""	],
	[  27, "ADD",	""	],
	[  28, "SUB",	""	],
	[  29, "BAND",	""	],
	[  30, "BOR",	""	],
	[  31, "BXOR",	""	],
	[  32, "BSHL",	""	],
	[  33, "BSHR",	""	],
	[  34, "EQU",	""	],
	[  35, "NEQU",	""	],
	[  36, "LESS",	""	],
	[  37, "GRTR",	""	],
	[  38, "LTEQ",	""	],
	[  39, "GTEQ",	""	],
	[ 168, "LDG",	"N"	],
	[ 169, "LDGV",	"N"	],
	[ 170, "LDL",	"N"	],
	[ 171, "LDLV",	"N"	],
	[ 172, "LDLAB",	"N"	],
	[ 173, "NUM",	"N"	],
	[ 174, "SAVG",	"N"	],
	[ 175, "SAVL",	"N"	],
	[  48, "STORE",	""	],
	[  49, "STORB",	""	],
	[ 178, "STACK",	"N"	],
	[ 179, "CALL",	"N"	],
	[  52, "CALR",	""	],
	[ 181, "EXEC",	"N"	],
	[ 182, "BRF",	"N"	],
	[ 183, "BRT",	"N"	],
	[ 184, "NBRF",	"N"	],
	[ 185, "NBRT",	"N"	],
	[ 186, "JUMP",	"N"	],
	[ 187, "UNEXT",	"N"	],
	[ 188, "DNEXT",	"N"	],
	[  61, "HALT",	""	],
	[ 190, "PUB",	"NB"	],
	[ 191, "EXT",	"NB"	],
	0
	];
	Tc[2] := [
	[ 129, "CLAB",	"N"	],
	[ 130, "DLAB",	"N"	],
	[ 131, "DECL",	"N"	],
	[ 132, "DATA",	"N"	],
	[ 133, "CREF",	"N"	],
	[ 134, "DREF",	"N"	],
	[ 135, "STR",	"NB"	],
	[ 136, "PSTR",	"NB"	],
	[ 137, "INIT",	"NN"	],
	[  10, "HDR",	""	],
	[  11, "END",	""	],
	[  12, "NEG",	""	],
	[  13, "LNOT",	""	],
	[  14, "BNOT",	""	],
	[  15, "POP",	""	],
	[ 144, "CLEAN",	"N"	],
	[  17, "NOP",	""	],
	[  18, "INDB",	""	],
	[  19, "IND",	""	],
	[  20, "DREFB",	""	],
	[  21, "DEREF",	""	],
	[ 150, "INCG",	"NN"	],
	[ 151, "INCL",	"NN"	],
	[  24, "MUL",	""	],
	[  25, "DIV",	""	],
	[  26, "MOD",	""	],
	[  27, "ADD",	""	],
	[  28, "SUB",	""	],
	[  29, "BAND",	""	],
	[  30, "BOR",	""	],
	[  31, "BXOR",	""	],
	[  32, "BSHL",	""	],
	[  33, "BSHR",	""	],
	[  34, "EQU",	""	],
	[  35, "NEQU",	""	],
	[  36, "LESS",	""	],
	[  37, "GRTR",	""	],
	[  38, "LTEQ",	""	],
	[  39, "GTEQ",	""	],
	[ 168, "LDG",	"N"	],
	[ 169, "LDGV",	"N"	],
	[ 170, "LDL",	"N"	],
	[ 171, "LDLV",	"N"	],
	[ 172, "LDLAB",	"N"	],
	[ 173, "NUM",	"N"	],
	[ 174, "SAVG",	"N"	],
	[ 175, "SAVL",	"N"	],
	[  48, "STORE",	""	],
	[  49, "STORB",	""	],
	[ 178, "STACK",	"N"	],
	[ 179, "CALL",	"N"	],
	[  52, "CALR",	""	],
	[ 181, "EXEC",	"N"	],
	[ 182, "BRF",	"N"	],
	[ 183, "BRT",	"N"	],
	[ 184, "NBRF",	"N"	],
	[ 185, "NBRT",	"N"	],
	[ 186, "JUMP",	"N"	],
	[ 187, "UNEXT",	"N"	],
	[ 188, "DNEXT",	"N"	],
	[  61, "HALT",	""	],
	[ 190, "PUB",	"NB"	],
	[ 191, "EXT",	"NB"	],
	[  64, "UMUL",	""	],
	[  65, "UDIV",	""	],
	[  66, "ULESS",	""	],
	[  67, "UGRTR",	""	],
	[  68, "ULTEQ",	""	],
	[  69, "UGTEQ",	""	],
	[  70, "DUP",	""	],
	[  71, "SWAP",	""	],
	[ 200, "LINE",	"N"	],
	[ 201, "GSYM",	"NBN"	],
	[ 202, "LSYM",	"NBN"	],
	0
	];
	Tc[3] := [
	[ 0x81,	"CLAB",	"N"	],
	[ 0x82,	"DLAB",	"N"	],
	[ 0x83,	"DECL",	"N"	],
	[ 0x84,	"DATA",	"N"	],
	[ 0x85,	"CREF",	"N"	],
	[ 0x86,	"DREF",	"N"	],
	[ 0x87,	"STR",	"NB"	],
	[ 0x88,	"PSTR",	"NB"	],
	[ 0x89,	"INIT",	"NN"	],
	[ 0x0A,	"HDR",	""	],
	[ 0x0B,	"END",	""	],
	[ 0x0C,	"CCTX",	""	],
	[ 0x0D,	"ECTX",	""	],
	[ 0x0E,	"POP",	""	],
	[ 0x0F,	"DUP",	""	],
	[ 0x10,	"SWAP",	""	],
	[ 0x91,	"STACK","N"	],
	[ 0x92,	"CLEAN","N"	],
	[ 0x13,	"NEG",	""	],
	[ 0x14,	"LNOT",	""	],
	[ 0x15,	"BNOT",	""	],
	[ 0x16,	"NOP",	""	],
	[ 0x97,	"INCG",	"NN"	],
	[ 0x98,	"INCI",	"NN"	],
	[ 0x99,	"INCL",	"NN"	],
	[ 0x1A,	"MUL",	""	],
	[ 0x1B,	"DIV",	""	],
	[ 0x1C,	"UMUL",	""	],
	[ 0x1D,	"UDIV",	""	],
	[ 0x1E,	"MOD",	""	],
	[ 0x1F,	"ADD",	""	],
	[ 0x20,	"SUB",	""	],
	[ 0x21,	"BAND",	""	],
	[ 0x22,	"BOR",	""	],
	[ 0x23,	"BXOR",	""	],
	[ 0x24,	"BSHL",	""	],
	[ 0x25,	"BSHR",	""	],
	[ 0x26,	"EQU",	""	],
	[ 0x27,	"NEQU",	""	],
	[ 0x28,	"LESS",	""	],
	[ 0x29,	"GRTR",	""	],
	[ 0x2A,	"LTEQ",	""	],
	[ 0x2B,	"GTEQ",	""	],
	[ 0x2C,	"ULESS",""	],
	[ 0x2D,	"UGRTR",""	],
	[ 0x2E,	"ULTEQ",""	],
	[ 0x2F,	"UGTEQ",""	],
	[ 0xB0,	"LDG",	"N"	],
	[ 0xB1,	"LDGV",	"N"	],
	[ 0xB2,	"LDL",	"N"	],
	[ 0xB3,	"LDLV",	"N"	],
	[ 0xB4,	"LDI",	"N"	],
	[ 0xB5,	"LDIV",	"N"	],
	[ 0xB6,	"LDLAB","N"	],
	[ 0xB7,	"NUM",	"N"	],
	[ 0x38,	"SELF",	""	],
	[ 0x39,	"IND",	""	],
	[ 0x3A,	"INDB",	""	],
	[ 0x3B,	"DEREF",""	],
	[ 0x3C,	"DREFB",""	],
	[ 0xBD,	"SAVG",	"N"	],
	[ 0xBE,	"SAVL",	"N"	],
	[ 0xBF,	"SAVI",	"N"	],
	[ 0x40,	"STORE",""	],
	[ 0x41,	"STORB",""	],
	[ 0xC2,	"CALL",	"N"	],
	[ 0x43,	"CALR",	""	],
	[ 0xC4,	"SYS",	"N"	],
	[ 0xC5,	"BRF",	"N"	],
	[ 0xC6,	"BRT",	"N"	],
	[ 0xC7,	"NBRF",	"N"	],
	[ 0xC8,	"NBRT",	"N"	],
	[ 0xC9,	"JUMP",	"N"	],
	[ 0xCA,	"UNEXT","N"	],
	[ 0xCB,	"DNEXT","N"	],
	[ 0xCC,	"HALT",	"N"	],
	[ 0xCD,	"PUB",	"NNB"	],
	[ 0xCE,	"EXT",	"NNB"	],
	[ 0xCF,	"CALX",	"N"	],
	[ 0xD0,	"LINE",	"N"	],
	[ 0xD1,	"GSYM",	"NNB"	],
	[ 0xD2,	"LSYM",	"NNB"	],
	[ 0xD3,	"ISYM",	"NNB"	],
	[ 0x54,	"CKSTK",""	],
	0
	];
	Td := [
		[ 0 ],
		[ 0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,
		  190, 191, 0 ],
		[ 0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,
		  190, 191, 200, 201, 202, 0 ],
		[ 0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,
		  0xCD,0xCE,0xD0,0xD1,0xD2,0xD3, 0 ]
	];
end


ws(s) Out.write(s, str.length(s));


wf(f, a) do var b::1024;
	ws(str.format(b, f, a));
	Out.flush();
end


wm(s) t.write(2, s, str.length(s));


wl(s) do
	t.write(2, s, str.length(s));
	t.write(2, Nlstr, str.length(Nlstr));
end


fail(m, n) do var b::256;
	wm("TXDUMP: ");
	wm(str.format(b, m, [(n)]));
	wm(Nlstr);
	halt 1;
end


rdc() do
	Addr := Addr+1;
	return In.rdch();
end


rdop() do var n;
	n := rdc();
	n := rdc() << 8 | n;
	if (n > 32767) n := n-K64;	! 32-bit hack
	return n;
end


vstr(s, k) do var b::1024, i, j, c;
	i := 0;
	j := 0;
	for (i=0, k) do
		c := s::i;
		ie (c < '\s' \/ c > '~') do
			str.format(@b::j, "\\%2:0X", [(c)]);
			j := j+3;
		end
		else ie (c = '\\') do
			b::j := '\\';
			b::(j+1) := '\\';
			j := j+2;
		end
		else do
			b::j := c;
			j := j+1;
		end
	end
	b::j := 0;
	wf("  \q%S\q", [(b)]);
end


getversion() do var op, a1, version, hdlen;
	op := rdc();
	Header::0 := 0;
	hdlen := 0;
	if (op = '#') do
		Header::0 := op;
		for (hdlen=1, 256) do
			a1 := rdc();
			Header::hdlen := a1;
			if (a1 = '\n') leave;
		end
		Header::hdlen := 0;
		op := rdc();
	end
	if (op \= IINIT) fail("not a Tcode program (magic match failed)", 0);
	a1 := rdop();
	version := a1;
	if (version < 1 \/ version > 3)
		fail("unsupported Tcode version: %D", version);
	Opcodes := Tc[version];
	Decls := Td[version];
	if (version > 1) rdop();
	In.move(hdlen, iostream.SEEK_SET);
	for (Lastop=0, 256)
		if (\Opcodes[Lastop])
			leave;
	for (Ndcl=0, 256)
		if (\Decls[Ndcl])
			leave;
	return version;
end


disasm() do
	var	op, op2, a1;
	var	sbuf::128;
	var	type, n, i;

	getversion();
	Addr := 0;
	while (1) do
		op := rdc();
		if (In.eof()) leave;
		op2 := op & 127;
		if (op2 > Lastop \/ op2 < 1)
			fail("invalid instruction (opcode=%D)", op);
		wf(O_hex-> "%4:0UX  %5LS": "%5UD  %5LS",
			[(Addr), (Opcodes[op2-1][1])]);
		type := Opcodes[op2-1][2];
		for (n=0, 3) do
			if (\type::n) leave;
			ie (type::n = 'N') do
				a1 := rdop();
				wf(O_hex-> "  %4:0UX": "  %6D", [(a1)]);
			end
			else ie (type::n = 'B') do
				for (i=0, a1) do
					sbuf::i := rdc();
				end
				vstr(sbuf, a1);
			end
			else ie (type::n = 'V') do
				for (i=0, a1) do
					rdc();
					sbuf::i := rdc();
				end
				vstr(sbuf, a1);
			end
			else do
				fail("bad argument type (INTERNAL ERROR)", 0);
			end
		end
		ws(Nlstr);
	end
end


info() do
	var	op, op2, a1, a2;
	var	version;
	var	sbuf::128;
	var	type, n, i;
	var	dsize, fsize, fp;
	var	argz, dclz;

	version := getversion();
	Addr := 0;
	dsize := 0;
	fsize := 0;
	fp := 0;
	dclz := 0;
	while (1) do
		op := rdc();
		if (In.eof()) leave;
		op2 := op & 127;
		if (op2 > Lastop \/ op2 < 1)
			fail("invalid instruction (opcode=0x%2:0X)", op);
		type := Opcodes[op2-1][2];
		argz := 1;
		for (n=0, 3) do
			if (\type::n) leave;
			ie (type::n = 'N') do
				a1 := rdop();
				argz := argz+2;
			end
			else ie (type::n = 'B') do
				for (i=0, a1) sbuf::i := rdc();
				argz := argz+a1;
			end
			else ie (type::n = 'V') do
				for (i=0, a1) do
					rdc();
					sbuf::i := rdc();
				end
				argz := argz + a1*2;
			end
			else do
				fail("bad argument type (INTERNAL ERROR)", 0);
			end
		end
		ie (op = IDATA \/ op = ICREF \/ op = IDREF)
			dsize := dsize + 2;
		else ie (op = IDECL)
			dsize := dsize + (a1-> a1*2: 2);
		else ie (op = ISTR)
			dsize := dsize + (a1*2) + 2;
		else ie (op = IPSTR)
			dsize := dsize + a1;
		else ie (version = 3 /\ op = STACK3)
			fp := fp + a1*2;
		else ie (version \= 3 /\ op = STACK12)
			fp := fp + a1*2;
		else if (op = IHDR)
			fp := 0;
		if (fp > fsize) fsize := fp;
		for (i=0, Ndcl)
			if (Decls[i] = op) do
				dclz := dclz + argz;
				leave;
			end
	end
	Addr := Addr-1;
	ie (O_one) do
		wf(O_hex-> "v=%D i=%5:0UD t=%5:0UD d=%5:0UD s=%5:0UD %S%S":
			"v=%D i=%5:0UD t=%5:0UD d=%5:0UD s=%5:0UD %S%S",
			[(version), (Addr), (Addr-dclz), (dsize), (fsize),
			 (Name), (Nlstr)]);
	end
	else do
		ie (O_hex) do
		 ie (Header::0)
		  wf("Tcode version:    %4D (%S)%S", [(version), (Header),
			(Nlstr)]);
		 else
		  wf("Tcode version:    %4D%S", [(version), (Nlstr)]);
		 wf("load image size:  %4:0UX%S", [(Addr), (Nlstr)]);
		 wf("text length:      %4:0UX%S", [(Addr-dclz), (Nlstr)]);
		 wf("data length:      %4:0UX%S", [(dsize), (Nlstr)]);
		 wf("min stack size:   %4:0UX + 100%S", [(fsize), (Nlstr)]);
		end
		else do
		 ie (Header::0)
		  wf("Tcode version:    %5D (%S)%S", [(version), (Header),
			(Nlstr)]);
		 else
		  wf("Tcode version:    %5D%S", [(version), (Nlstr)]);
		 wf("load image size:  %5UD%S", [(Addr), (Nlstr)]);
		 wf("text length:      %5UD%S", [(Addr-dclz), (Nlstr)]);
		 wf("data length:      %5UD%S", [(dsize), (Nlstr)]);
		 wf("min stack size:   %5UD + 256%S", [(fsize), (Nlstr)]);
		end
	end
end


tm_path() do var i;
	getversion();
	ie (O_one) do
		if (\Header::0) return;
		i := str.scan(Header, '/');
		if (i<0) i := 0;
		ws(@Header::i);
	end
	else do
		wf("%S:\t%S", [(Name), (Header::0-> Header: "(none)")]);
	end
	ws(Nlstr);
end


process() do
	ie (O_mode = M_UX) disasm();
	else ie (O_mode = M_INFO) info();
	else ie (O_mode = M_BANG) tm_path();
	else ;
end


usage() do
	wm(Nlstr);
	wl("Usage: txdump [-imux1] [file ...]");
	wm(Nlstr);
	wl("-i - summarize Tcode sizes (TXINFO mode)");
	wl("-m - print the #!header of the module");
	wl("-u - unassemble (UX mode)");
	wl("-x - use hex numbers (default = decimal)");
	wl("-1 - (with -i) print one-line summaries");
	wl("     (with -m) print only the interpreter path");
	wm(Nlstr);
	halt 1;
end


defaults() do
	O_mode := M_INFO;
	O_hex := 0;
	O_one := 0;
end


do
	var	arg::128;
	var	i, j, c, k;
	var	mode;

	init();
	defaults();
	i := 1; while (1) do
		k := t.getarg(i, arg, 127);
		if (k < 0 \/ arg::0 \= '-') leave;
		for (j=1, k) do
			c := arg::j;
			ie (c = 'i') O_mode := M_INFO;
			else ie (c = 'm') O_mode := M_BANG;
			else ie (c = 'u') O_mode := M_UX;
			else ie (c = 'x') O_hex := 1;
			else ie (c = '1') O_one := 1;
			else usage();
		end
		i := i+1;
	end
	Out.create(1, Outbuf, BUFSIZE, iostream.FWRITE);
	ie (k < 0) do
		Name := "(stdin)";
		In.create(0, Inbuf, BUFSIZE, iostream.FREAD);
		Out.create(1, Outbuf, BUFSIZE, iostream.FWRITE);
		process();
	end
	else while (k >= 0) do
		Name := arg;
		ie (In.open(arg, Inbuf, BUFSIZE, iostream.FREAD) = %1) do
			fail("%S: cannot open", arg);
		end
		else do
			process();
			In.close();
		end
		i := i+1;
		k := t.getarg(i, arg, 127);
	end
	Out.flush();
end
